package com.bsoft.api.controller;

import com.bsoft.api.common.Result;
import com.bsoft.api.common.annotations.Token;
import com.bsoft.api.model.SerDisease;
import com.bsoft.api.model.reqmodel.Disease;
import com.bsoft.api.model.respmodel.DiseaseLevel;
import com.bsoft.api.service.SerDiseaseService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@Api(tags = "疾病信息Api")
@RestController
public class SerDiseaseController {

    @Autowired
    private SerDiseaseService serDiseaseService;
    /**
     * 根据pageId查询板块数值
     * @return
     * @throws Exception
     */
    @PostMapping("disease/level")
    @Token
    @ApiOperation("根据等级查询疾病信息")
    public Object getDiseaseByLevel(@RequestBody Disease.DiseaseLevel disease) throws InterruptedException {
        List<DiseaseLevel> diseaseLevel = serDiseaseService.selectListByLevel(disease.getDate(),disease.getDiseaseId());
        return Result.success(diseaseLevel);
    }

    @PostMapping("disease/name")
    @Token
    @ApiOperation("根据疾病名称查询疾病信息")
    public  Object getDiseaseByMdcName(@RequestBody Disease.DiseaseName disease) throws InterruptedException {
        List<SerDisease> list = serDiseaseService.selectByMdcName(disease.getDate(),disease.getMdcName());
        return Result.success(list);
    }

    @PostMapping("disease/level/info")
    @Token
    @ApiOperation("查询特定等级下所有数据")
    public  Object getDiseaseByLevelSon(@RequestBody Disease.DiseaseLevelSon disease) throws InterruptedException {
        List<SerDisease> list = serDiseaseService.selectByLevel(disease.getDate(),disease.getLevel().intValue());
        return Result.success(list);
    }

}
