package com.bsoft.api.service.Impl;

import com.bsoft.api.mapper.SerDiseaseMapper;
import com.bsoft.api.model.SerDisease;
import com.bsoft.api.model.reqmodel.Disease;
import com.bsoft.api.model.respmodel.DiseaseLevel;
import com.bsoft.api.service.SerDiseaseService;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Service
public class SerDiseaseServiceImpl implements SerDiseaseService {
    @Resource
    private SerDiseaseMapper serDiseaseMapper;

    @Override
    public List<DiseaseLevel> selectListByLevel(String date, Integer diseaseId){
        SerDisease disease = serDiseaseMapper.selectByPrimaryKey(Long.valueOf(diseaseId));
        if(disease==null){
            return null;
        }
        //查询父级菜单对象
        DiseaseLevel diseaseLevel = serDiseaseMapper.selectParentById(date,diseaseId);
        List<DiseaseLevel> parentList = new ArrayList<>();

        //查询同级菜单列表
        List<SerDisease> serDiseaseList =  serDiseaseMapper.selectByLevel(date,disease.getLevel().intValue());
        List<DiseaseLevel> diseaseLevelList = new ArrayList<>();
        for (SerDisease serDiseases: serDiseaseList) {
            DiseaseLevel diseaseLevel1 = new DiseaseLevel();
            //查询子级菜单列表
            if(serDiseases.getId().intValue()==diseaseId){
                List<DiseaseLevel> diseaseLevelList1 = serDiseaseMapper.selectSonById(date,diseaseId);
                diseaseLevel1.setDiseaseLevelList(diseaseLevelList1);
            }
            diseaseLevel1.setDate(serDiseases.getDate());
            diseaseLevel1.setId(serDiseases.getId());
            diseaseLevel1.setLevel(serDiseases.getLevel());
            diseaseLevel1.setMdcCode(serDiseases.getMdcCode());
            diseaseLevel1.setMdcName(serDiseases.getMdcName());
            diseaseLevel1.setMdcNum(serDiseases.getMdcNum());
            diseaseLevel1.setOrgId(serDiseases.getOrgId());
            diseaseLevel1.setOrgName(serDiseases.getOrgName());
            diseaseLevel1.setParentId(serDiseases.getParentId());
            diseaseLevelList.add(diseaseLevel1);
        }
        if(diseaseLevel!=null){
            diseaseLevel.setDiseaseLevelList(diseaseLevelList);
            parentList.add(diseaseLevel);
            return parentList;
        }else {
            return diseaseLevelList;
        }
    }

    @Override
    public List<SerDisease> selectByMdcName(String date, String mdcName) {
        return serDiseaseMapper.selectByMdcName(date,mdcName);
    }

    @Override
    public List<SerDisease> selectByLevel(String date, Integer level) {
        return serDiseaseMapper.selectByLevel(date,level);


    }
}
